# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RegisteredModelInfo(BaseModel):
    """
    RegisteredModelInfo
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The name of the registered model")
    catalog_name: Optional[StrictStr] = Field(default=None, description="The name of the catalog where the schema and the registered model reside")
    schema_name: Optional[StrictStr] = Field(default=None, description="The name of the schema where the registered model resides")
    storage_location: Optional[StrictStr] = Field(default=None, description="The storage location on the cloud under which model version data files are stored")
    full_name: Optional[StrictStr] = Field(default=None, description="The three-level (fully qualified) name of the registered model")
    comment: Optional[StrictStr] = Field(default=None, description="The comment attached to the registered model")
    owner: Optional[StrictStr] = Field(default=None, description="The identifier of the user who owns the registered model")
    created_at: Optional[StrictInt] = Field(default=None, description="Creation timestamp of the registered model in milliseconds since the Unix epoch")
    created_by: Optional[StrictStr] = Field(default=None, description="The identifier of the user who created the registered model")
    updated_at: Optional[StrictInt] = Field(default=None, description="Last-update timestamp of the registered model in milliseconds since the Unix epoch")
    updated_by: Optional[StrictStr] = Field(default=None, description="The identifier of the user who updated the registered model last time")
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the registered model.")
    __properties: ClassVar[List[str]] = ["name", "catalog_name", "schema_name", "storage_location", "full_name", "comment", "owner", "created_at", "created_by", "updated_at", "updated_by", "id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RegisteredModelInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RegisteredModelInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "catalog_name": obj.get("catalog_name"),
            "schema_name": obj.get("schema_name"),
            "storage_location": obj.get("storage_location"),
            "full_name": obj.get("full_name"),
            "comment": obj.get("comment"),
            "owner": obj.get("owner"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by"),
            "id": obj.get("id")
        })
        return _obj


