# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from unitycatalog.client.models.aws_credentials import AwsCredentials
from unitycatalog.client.models.azure_user_delegation_sas import AzureUserDelegationSAS
from unitycatalog.client.models.gcp_oauth_token import GcpOauthToken
from typing import Optional, Set
from typing_extensions import Self

class TemporaryCredentials(BaseModel):
    """
    TemporaryCredentials
    """ # noqa: E501
    aws_temp_credentials: Optional[AwsCredentials] = None
    azure_user_delegation_sas: Optional[AzureUserDelegationSAS] = None
    gcp_oauth_token: Optional[GcpOauthToken] = None
    expiration_time: Optional[StrictInt] = Field(default=None, description="Server time when the credential will expire, in epoch milliseconds. The API client is advised to cache the credential given this expiration time. ")
    __properties: ClassVar[List[str]] = ["aws_temp_credentials", "azure_user_delegation_sas", "gcp_oauth_token", "expiration_time"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TemporaryCredentials from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aws_temp_credentials
        if self.aws_temp_credentials:
            _dict['aws_temp_credentials'] = self.aws_temp_credentials.to_dict()
        # override the default output from pydantic by calling `to_dict()` of azure_user_delegation_sas
        if self.azure_user_delegation_sas:
            _dict['azure_user_delegation_sas'] = self.azure_user_delegation_sas.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gcp_oauth_token
        if self.gcp_oauth_token:
            _dict['gcp_oauth_token'] = self.gcp_oauth_token.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TemporaryCredentials from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aws_temp_credentials": AwsCredentials.from_dict(obj["aws_temp_credentials"]) if obj.get("aws_temp_credentials") is not None else None,
            "azure_user_delegation_sas": AzureUserDelegationSAS.from_dict(obj["azure_user_delegation_sas"]) if obj.get("azure_user_delegation_sas") is not None else None,
            "gcp_oauth_token": GcpOauthToken.from_dict(obj["gcp_oauth_token"]) if obj.get("gcp_oauth_token") is not None else None,
            "expiration_time": obj.get("expiration_time")
        })
        return _obj


